package ovh.toms.flyfeather;

import com.google.common.reflect.ClassPath;
import lombok.AccessLevel;
import lombok.Getter;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.plugin.java.JavaPlugin;
import ovh.toms.flyfeather.misc.ConfigManager;
import ovh.toms.flyfeather.misc.Variables;
import ovh.toms.flyfeather.util.RegisterUtil;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Created by Tom S. on 15.12.17
 * This code is property of Tysox.de Development
 * (c) 2015-2017
 */
@Getter(AccessLevel.PUBLIC)
public class FlyFeather extends JavaPlugin {

    @Getter
    private static FlyFeather instance;

    @Getter
    private ConfigManager configManager;

    private List<Player> enabledFly = new ArrayList<>();

    private RegisterUtil<FlyFeather> registerUtil;

    @Override
    public void onLoad() {
        instance = this;
    }

    @Override
    public void onEnable() {
        registerUtil = new RegisterUtil<>(this);
        configManager = new ConfigManager();
        Variables.initialize();
        registerListener();
    }

    private void registerListener() {
        try {
            for (ClassPath.ClassInfo classInfo : ClassPath.from(getClassLoader()).getTopLevelClasses("ovh.toms.flyfeather.listener")) {
                Class<?> clazz = Class.forName(classInfo.getName());
                if (Listener.class.isAssignableFrom(clazz)) {
                    registerUtil.registerEvents(clazz);
                }
            }
        } catch (IOException | ClassNotFoundException exception) {
            Logger.getLogger(RegisterUtil.class.getName()).log(Level.SEVERE, null, exception);
        }
    }
}
